import pyglet
import PySimpleGUI as sg

def beepfunc(dt=0, didIBeep=[0,1,1,2,1], type='Consant'):
    if not dt==0:
        beep1 = pyglet.media.load("media/beep1.mp3")
        beep1.play()
        
        if not type == 'Constant':
            print(didIBeep)
            currentRun=int((didIBeep[0] % didIBeep[1])+1)
            didIBeep[0]=currentRun
            if currentRun==1:
                pyglet.clock.unschedule(beepfunc)
                didIBeep[1] = (didIBeep[1]+didIBeep[4])%didIBeep[2]
                if didIBeep[1]<=0:
                    didIBeep[1]=didIBeep[2]
                pyglet.clock.schedule_interval(beepfunc, didIBeep[3]/didIBeep[1],didIBeep, type)

    else:
        return didIBeep
    
def timeToBeep(BPS, period=1):
    return (period)/BPS

def playBeep(didIBeep, type, BPS, play):
    if play:
        pyglet.clock.unschedule(beepfunc)
        pyglet.clock.schedule_interval(beepfunc, timeToBeep(BPS),didIBeep, type)

def MediaPlayerGUI():
    BPS = 1
    timer = 10
    play = False
    framelength = 10
    didIBeep = [1,1,10,2,1]
    
    # define layout of the rows
    layout = [[sg.Text('Beat player', font=("Helvetica", 25))],
              [sg.Text('Current BPS: 1', size=(15, 2), font=("Helvetica", 14), key='BPS'),sg.Button('', key='Play Toggl', image_filename = 'media/pause.png', image_size=(50,50), image_subsample=2), sg.Text(' ' * 2)],
              [],
              [sg.TabGroup([[
                    sg.Tab('Constant',[
                        [sg.Text('BPS:')],
                        [sg.Slider(range=(1,10), key='constant slider', orientation='h', change_submits=True)]
                    ]),
                    sg.Tab('Accelerating',[
                        [sg.Text('Max Beeps:')],
                        [sg.Slider(range=(1,15), default_value=10, key='acceleration  max slider', orientation='h', change_submits=True)],
                        [sg.Text('Beep period:')],
                        [sg.Slider(range=(1,3), resolution=0.1, default_value=2, key='acceleration  period slider', orientation='h', change_submits=True)],
                        [sg.Text('Acceleration rate:')],
                        [sg.Slider(range=(-2,2), default_value=1, key='acceleration  rate slider', orientation='h', change_submits=True)],
                    ])
                ]], key='beepType', size=(250,250), enable_events=True)]
              ]

    window = sg.Window('Media File Player', layout,
                       default_element_size=(20, 1),
                       return_keyboard_events=True)

    while True:
        pyglet.clock.tick()
        event, values = window.read(timeout=framelength, timeout_key=' ')

        if event == 'Exit' or event == sg.WIN_CLOSED:
            break
        else:
            type = values['beepType']
            if type == 'Constant':
                window['BPS'].update(f'Current BPS: {BPS}')
            else:
                window['BPS'].update(f'Current BPS: {didIBeep[1]}')
            window['constant slider'].update(BPS)
            window['acceleration  max slider'].update(didIBeep[2])
            window['acceleration  period slider'].update(didIBeep[3])
            window['acceleration  rate slider'].update(didIBeep[4])
        # If a button was pressed, display it on the GUI by updating the text element

        match event:
            case 'constant slider':
                BPS = values['constant slider']
                playBeep(didIBeep,type,BPS,play)
            case 'acceleration  max slider':
                didIBeep[2] = int(values['acceleration  max slider'])
                playBeep(didIBeep,type,BPS,play)
            case 'acceleration  period slider':
                didIBeep[3] = values['acceleration  period slider']
                playBeep(didIBeep,type,BPS,play)
            case 'acceleration  rate slider':
                didIBeep[4] = int(values['acceleration  rate slider'])
                playBeep(didIBeep,type,BPS,play)
            case 'a':
                BPS -=1
                BPS=max(BPS,1)
                didIBeep[3]-=0.1
                didIBeep[3]=max(didIBeep[3],1) 
                playBeep(didIBeep,type,BPS,play)
            case 'd':
                BPS +=1    
                didIBeep[3]+=0.1    
                playBeep(didIBeep,type,BPS,play)
            case 'q':   
                didIBeep[2]-=1 
                didIBeep[2]=max(didIBeep[2],1)   
                playBeep(didIBeep,type,BPS,play)
            case 'e':   
                didIBeep[2]+=1    
                playBeep(didIBeep,type,BPS,play)
            case 'z':   
                didIBeep[4]-=1  
                didIBeep[4]=max(didIBeep[4],-2)   
                playBeep(didIBeep,type,BPS,play)
            case 'c':   
                didIBeep[4]+=1    
                playBeep(didIBeep,type,BPS,play)
            case 'beepType':
                if play:
                    playBeep(didIBeep,type,BPS,play)
            case 's'|'Play Toggl':
                play = not play
                if play:
                    window['Play Toggl'].update( image_filename = 'media/play.png', image_size=(50,50), image_subsample=2)
                    playBeep(didIBeep,type,BPS,play)
                else:
                    window['Play Toggl'].update( image_filename = 'media/pause.png', image_size=(50,50), image_subsample=2)
                    pyglet.clock.unschedule(beepfunc)

    window.close()

MediaPlayerGUI()
